#ifndef nunchuk_h
#define nunchuk_h

#define NUNCHUK_ADDR 0x52 // TWI address of nunchuk

#define ZERO_X  121
#define ZERO_Y  126

#define ZERO_ACC_X  512
#define ZERO_ACC_Y  512
#define ZERO_ACC_Z  512


typedef struct {
	uint8_t x;
	uint8_t y;
	uint16_t acc_x;
	uint16_t acc_y;
	uint16_t acc_z;
	uint8_t but_z;
	uint8_t but_c;
} nunchuk_data_t;


typedef struct {
	int16_t x;
	int16_t y;
	int16_t roll;
	int16_t pitch;
	uint8_t but_z;
	uint8_t but_c;
} nunchuk_axis_t;

uint8_t nunchuk_init ();
uint8_t nunchuk_read(nunchuk_data_t *nunchuk_data);

int16_t nunchuk_calc_roll(nunchuk_data_t *nunchuk_data);
int16_t nunchuk_calc_pitch(nunchuk_data_t *nunchuk_data);

void nunchuk_calc_axis(const nunchuk_data_t *nunchuk_data, nunchuk_axis_t *nunchuk_axis);

#endif // nunchuk_h